
#import <appkit/appkit.h>

#import <eoaccess/EOAdaptor.h>

// Exported Definitions

#define HOSTNAME	@"hostname"
#define DATABASE	@"database"
#define NAME		@"name"
#define PASSWORD	@"password"

// Forward class declarations

@class MiniSQLAdaptorChannel;

// Interface

@interface MiniSQLAdaptor:EOAdaptor
{
    int		openChannels;
}

- (Class)expressionClass;
// Returns the subclass of EOSQLExpression used by this adaptor for query
// language expressions.  You directly invoke this method, but an
// adaptor subclass must properly implement this method.

- (EOAdaptorContext *) createAdaptorContext;
// Returns a new EOAdaptorContext, or nil if a new context cannot be
// created.  EOAdaptors by default have no contexts at all.  The newly
// created context retains its adaptor.

- (BOOL) hasOpenChannels;
// Returns YES if the adaptor has any open channels, NO otherwise. See
// -openChannel in EOAdaptorChannel.h.

- (void) miniSQLChannelDidConnect;
- (void) miniSQLChannelDidDisconnect;

- (BOOL)hasValidConnectionDictionary;
// Returns YES if the adaptor can connect with the current connection
// dictionary, NO otherwise. An actual connection is made when the first
// adaptor channel is sent an -openChannel message.

- valueForCString:(const char *)expression
attribute:(EOAttribute *)attribute
zone:(NSZone *)zone;
// Conceptually the inverse of the receiver's formatValue:forAttribute:
// method. Returns a value of the appropriate class given database
// output <expression>, allocated from <zone>. 

@end
